#!/usr/local/php/bin/php
<?
/**
 * gate.cgi -     cgi -  CGI
 * 
 *  ZlobnyGrif (c) 2006
 * 
 * ===========================================================================
 * !!!
 * ===========================================================================
 *        RewriteBase 
 * $http_path!
 * 
 *    http://my.site.ru      
 *  http://my.site.ru/cgi-bin/ , 
 * 
 * RewriteBase /cgi-bin       -  .htaccess,  7
 * $http_path = '/cgi-bin';   -   gate.cgi,  52
 * 
 *      711   gate.cgi
 * 
 * 
 * 
 *  :
 *    1.    cgi_adapter    $CGI
 *    2.           
 *         REQUEST_URI
 *    3.  
 *
 *     .htaccess,      , 
 *   
 * ---------------- .htaccess ------------------------

## Sometimes follow setting needs for work!
# Options FollowSymlinks

RewriteEngine on

## Script's folder 
RewriteBase /milo

## If script is PHP-script, include him
RewriteCond %{REQUEST_URI} \.php$
RewriteRule ^.*$ gate.cgi?%{QUERY_STRING} [L]

 * ---------------- EOF      --------------------------
 * 
**/

// ----------------------------------------------------

$http_path = '/milo';   //       

// ----------------------------------------------------


include('cgi_adapter.class.php');

define('PHP_MODE'     , defined('STDIN') ? 'CGI' : 'SAFE' );
define('IS_CGI_MODE'  , PHP_MODE === 'CGI'                );
define('IS_SAFE_MODE' , PHP_MODE === 'CGI'                );

$CGI = & new cgi_adapter();

// error_reporting(E_ALL);

$file  = '';
$query = '';

@list( $file, $query ) = split( '\\?', $_SERVER['REQUEST_URI'], 2 );;

$file = preg_replace('~^/?'. $http_path .'/?~', '', $file);
if ( !$file ) $file = 'index.php';


if ( !preg_match('/\\.php$/', $file) ) $file .= '/index.php';
//     ,    , 
//         -!

if ( preg_match('/\\.php$/', $file) )
{
	
	if ( $file !== basename( __FILE__ ) && is_readable( $file ) && !substr_count( $file, '/../' ) )
	{
		// Ok - include file
		include( $file );
	}
	else
	{
		// Bad file
		echo '<h1>Can\'t read file ', $file ,' </h1>';
		echo 'Please check query string';
//		echo '<pre>';
//		var_dump($file);
//		echo '</pre>';
	}
}
else 
{
	// Bad file name
	echo "<h1>Bad file name $file</h1>";
	echo 'Please check query string';
//	echo '<pre>';
//	var_dump($file);
//	echo '</pre>';
}

?>